#! /home/song3/anaconda3/bin/python


import numpy as np
from matplotlib import pyplot as plt
import sys, struct
import os.path
import warnings
warnings.simplefilter('ignore')
from bitarray import bitarray

from bitio import bit_open




def readFile(filename):
    data = np.fromfile(filename,dtype=np.complex64)
    # real_data = data[0::2]
    # img_data = data[1::2]
    # data = real_data + img_data*1j
    return data



def writeFile(filename,numbers):
    f = open(filename,"wb")
    bits = bitarray("".join(["{0:02b}".format(num) for num in numbers]))
    bits.tofile(f)
    f.close()

if __name__ == "__main__":
    signal = readFile("./modulated_pic.dat")
    # TODO: write a function to demodulate the file
    # The file uses QPSK, the constellation looks like this:
    #     |
    # 1   |   0
    # ----------        
    # 2   |   3
    #     |

    # The amptitude is 1
    
    numbers = demod(signal)
    writeFile("./demod_pic1.jpg",numbers)

    # TODO
    # When you have done this, try to write your own modulation and demodulation
    # to implement QAM 16


